from collections import deque

def find(n, m, k, roads, guards):
    graph = [[] for _ in range(n + 1)]
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    guarded = set()
    
    for p, h in guards:
        visited = [False] * (n + 1)
        queue = deque([(p, 0)])
        visited[p] = True
        
        while queue:
            current, dist = queue.popleft()
            if dist > h:
                break
            guarded.add(current)
            for neighbor in graph[current]:
                if not visited[neighbor]:
                    visited[neighbor] = True
                    queue.append((neighbor, dist + 1))
    
    guarded = sorted(guarded)
    print(len(guarded))
    if guarded:
        print(" ".join(map(str, guarded)))
    else:
        print()

n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

find(n, m, k, roads, guards)