from collections import deque, defaultdict


def find(start, max_distance, graph):
    visited = set()
    queue = deque([(start, 0)]) 
    visited.add(start)

    while queue:
        node, dist = queue.popleft()
        if dist < max_distance:
            for neighbor in graph[node]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))

    return visited


data = input().splitlines()
print(data)
n, m, k = map(int, data[0].split())
graph = defaultdict(list)
for i in range(1, m + 1):
    y = input().splitlines()
    a, b = map(int, y[0].split())
    graph[a].append(b)
    graph[b].append(a)
guarded_warehouses = set()
for i in range(m + 1, m + k + 1):
    x = input().splitlines()
    p, h = map(int, x[0].split())
    reachable = find(p, h, graph)
    guarded_warehouses.update(reachable)
guarded_warehouses = sorted(guarded_warehouses)
print(len(guarded_warehouses))
if guarded_warehouses:
    print(' '.join(map(str, guarded_warehouses)))
else:
    print() 
