import math

def distance(p1, p2):
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)

def f(n, points):
    dist = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            dist[i][j] = distance(points[i], points[j])
    INF = float('inf')
    dp = [[INF] * n for _ in range(1 << n)]
    for i in range(n):
        dp[1 << i][i] = 0
    for mask in range(1 << n):
        for u in range(n):
            if (mask & (1 << u)) == 0:
                continue
            for v in range(n):
                if (mask & (1 << v)) != 0:
                    continue
                dp[mask | (1 << v)][v] = min(dp[mask | (1 << v)][v], dp[mask][u] + dist[u][v])
    result = INF
    for i in range(n):
        result = min(result, dp[(1 << n) - 1][i])
    
    return result

n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

result = f(n, points)
print(f"{result:.7f}")